import torchattacks
import torch


import gc
import numpy as np
import torch.nn as nn
import torch.optim as optim
import matplotlib.pyplot as plt
import torch.nn.functional as F
import torchvision.models as models


from tqdm import tqdm
from collections import OrderedDict
from scipy.sparse.linalg import svds
from torchvision import datasets, transforms
from IPython import embed
import copy


import torch
import torch.nn as nn
import torch.nn.functional as F
from torch.autograd import Variable
import torch.optim as optim
import seaborn as sns
from torch import linalg 
import math
from torch.nn.parameter import Parameter
from torch.utils.data import TensorDataset, DataLoader

import os, sys, argparse


parser = argparse.ArgumentParser()
parser.add_argument('--alpha',      default='1',   type=float, help='learning step size')
parser.add_argument('--beta',                default=0.1,  type=float, help='update step size')
parser.add_argument('--adv_size',         default=8/255,        type=float, help='adv_size')
parser.add_argument('--update_epoch',         default=5,        type=int, help='epoch')
parser.add_argument('--gpu',         default=5,        type=int, help='gpu')
# gflags.DEFINE_float('alpha', 1, 'learning step size')
# gflags.DEFINE_float('beta', 0.1, 'update step size')
# gflags.DEFINE_float('adv_size', 8/255, 'adv_size')
opt = parser.parse_args()
# gflags.DEFINE_string('method', 'MDA1', 'Input data file')
# gflags.DEFINE_string('datasets', 'FashionMNIST', 'datasets file')

# gflags.DEFINE_float('lambd', 0.1, 'L2 weight')
# gflags.DEFINE_float('lbd', 0.001, 'L1 weight')
# gflags.DEFINE_float('gamma', 10, 'L1 panelty')
# gflags.DEFINE_float('theta', 1000, 'L1 weight')
# gflags.DEFINE_float('step_size1', .001, 'Learning rate1')
# gflags.DEFINE_float('step_size2', .00001, 'Learning rate2')

# gflags.DEFINE_float('alpha', 0.1, 'recur')
# gflags.DEFINE_float('rho', .0001, 'pho')


# gflags.DEFINE_boolean('init', True, 'Init the weight')

################## MAIN ######################



# Flags(sys.argv)
torch.cuda.set_device(opt.gpu) 
device = torch.device("cuda" if torch.cuda.is_available() else "cpu")

class Linear(nn.Module):
    
    __constants__ = ['in_features', 'out_features']
    in_features: int
    out_features: int
    weight: torch.Tensor

    def __init__(self, in_features: int, out_features: int, bias: bool = True,
                 device=None, dtype=None) -> None:
        factory_kwargs = {'device': device, 'dtype': dtype}
        super(Linear, self).__init__()
        self.in_features = in_features
        self.out_features = out_features
        self.weight = Parameter(torch.empty((out_features, in_features), **factory_kwargs))
        self.weight_grad = None

        if bias:
            self.bias = Parameter(torch.empty(out_features, **factory_kwargs))
        else:
            self.register_parameter('bias', None)
        self.reset_parameters()

    def reset_parameters(self) -> None:
#         stdv = 1. / math.sqrt(self.weight.size(1))
#         self.weight.data.uniform_(-stdv, stdv)
        nn.init.kaiming_uniform_(self.weight, a=math.sqrt(5))
        if self.bias is not None:
#             self.bias.data.uniform_(-stdv, stdv)
            fan_in, _ = nn.init._calculate_fan_in_and_fan_out(self.weight)
            bound = 1 / math.sqrt(fan_in) if fan_in > 0 else 0
            nn.init.uniform_(self.bias, -bound, bound)

    def forward(self, input: torch.Tensor) -> torch.Tensor:
        if self.weight_grad is None:
            return F.linear(input, (self.weight), self.bias)
        else:
            return F.linear(input, (self.weight+self.weight_grad), self.bias)

    def extra_repr(self) -> str:
        return 'in_features={}, out_features={}, bias={}'.format(
            self.in_features, self.out_features, self.bias is not None
        )

# dataset parameters
im_size             = 28
padded_im_size      = 32
C                   = 10
input_ch            = 1

# Optimization Criterion
loss_name = 'CrossEntropyLoss'
# loss_name = 'MSELoss'

# Optimization hyperparameters
lr_decay            = 0.1

# Best lr after hyperparameter tuning
if loss_name == 'CrossEntropyLoss':
    lr = 0.0679
elif loss_name == 'MSELoss':
    lr = 0.0184

epochs              = 10
epochs_lr_decay     = [epochs//3, epochs*2//3]

batch_size          = 1024

momentum            = 0.9
weight_decay        = 5e-4

# analysis parameters
# epoch_list          = [1,   2,   3,   4,   5,   6,   7,   8,   9,   10,   11,
#                        12,  13,  14,  16,  17,  19,  20,  22,  24,  27,   29,
#                        32,  35,  38,  42,  45,  50,  54,  59,  65,  71,   77,
#                        85,  92,  101, 110, 121, 132, 144, 158, 172, 188,  206,
#                        225, 245, 268, 293, 320, 350]

epoch_list          = [1,      3,      5,      7,      11,
                       12,    17,    22,   27,   29,
                       32,   38,    45,  50,   59,  65,    77,
                       85,  92,  101, 110, 121, 132, 144, 158, 172, 188,  206,
                       225, 245, 268, 293, 320, 350]



def train(model, criterion, device, num_classes, train_loader, optimizer, epoch):
    model.train()
    
    pbar = tqdm(total=len(train_loader), position=0, leave=True)
    for batch_idx, (data, target) in enumerate(train_loader, start=1):
        data=data.view(data.shape[0],-1)
        if data.shape[0] != batch_size:
            continue
        
        data, target = data.to(device), target.to(device)
#         data.requires_grad = True
        optimizer.zero_grad()
        out = model(data)
        if str(criterion) == 'CrossEntropyLoss()':
            loss = criterion(out, target)
        elif str(criterion) == 'MSELoss()':
            loss = criterion(out, F.one_hot(target, num_classes=num_classes).float()) 
        
        loss.backward()
        optimizer.step()

        accuracy = torch.mean((torch.argmax(out,dim=1)==target).float()).item()

        pbar.update(1)
        pbar.set_description(
            'Train\t\tEpoch: {} [{}/{} ({:.0f}%)] \t'
            'Batch Loss: {:.6f} \t'
            'Batch Accuracy: {:.6f}'.format(
                epoch,
                batch_idx,
                len(train_loader),
                100. * batch_idx / len(train_loader),
                loss.item(),
                accuracy))
        
#         if debug and batch_idx > 20:
#             break
    pbar.close()


    
def test(model, device, num_classes, test_loader):
    model.eval()
    n_crr = 0
    size = 0
#     pbar = tqdm(total=len(test_loader), position=0, leave=True)
    for batch_idx, (data, target) in enumerate(test_loader, start=1):
        data=data.view(data.shape[0],-1)
#         if data.shape[0] != batch_size:
#             continue
        
        data, target = data.to(device), target.to(device)
        optimizer.zero_grad()
        out = model(data)
        
        n_crr += torch.sum((torch.argmax(out,dim=1)==target).float()).item()
        size+=data.shape[0]
    acc = n_crr/size
    print(acc)

def attack(model,test_loader,device,adv_size=8/255):
#     data = []
    size = 0
    n_crr = 0
    alpha = adv_size/4+0.5/255
    atk = torchattacks.PGD(model, eps=adv_size, alpha=alpha, steps=4)
    for i, (data, target) in enumerate(test_loader):
#         print(data.shape)
        data=data.view(data.shape[0],-1)
        adv_images = atk(data, target).to(device)
#         print(adv_images.shape)
#         data.append(X)
        target = target.to(device)
        outputs = model(adv_images)
        
        n_crr += torch.sum((torch.argmax(outputs,dim=1)==target).float()).item()
        size+=data.shape[0]
    print(n_crr/size)
        
#         correct += (pre == labels).sum()

def train_robust_data(model, criterion, device, num_classes, train_loader,robust_train_loader, optimizer, epoch,alpha=1,beta=0.1,adv_size=8/255):
    model.load_state_dict(torch.load("checkpoint.ckpt"))
    model.train()
    robust_data=[]
    pbar = tqdm(total=len(train_loader), position=0, leave=True)
#     robust_dataset = []
#     robust_label = []
    for batch_idx, ((data, target),(robust_data, robust_target)) in enumerate(zip(train_loader,robust_train_loader), start=1):
        data=data.view(data.shape[0],-1)
#         fig = plt.figure
#         plt.imshow(robust_data[0].detach().cpu().view(28,28).numpy(), cmap='gray')
#         plt.show() 
        robust_data=robust_data.view(robust_data.shape[0],-1)
         
#         print(robust_data[0])            
        data, target = data.to(device), target.to(device)
        robust_data, robust_target = robust_data.to(device), robust_target.to(device)
                  
        robust_data.requires_grad = True
        data.requires_grad = True
                    
        optimizer.zero_grad()
        out = model(robust_data)
        if str(criterion) == 'CrossEntropyLoss()':
            loss = criterion(out, robust_target)
        elif str(criterion) == 'MSELoss()':
            loss = criterion(out, F.one_hot(target, num_classes=num_classes).float()) 
#         print(model.linear1.weight.grad)
        loss.backward(retain_graph=True,create_graph=True)
#         print(model.linear1.weight.grad)
        model.fill_gd(alpha= alpha)

        out_nat = model(data)
        loss_nat = criterion(out_nat, target)
        gd_nat  = torch.autograd.grad(loss_nat, data, grad_outputs=None, only_inputs=True, retain_graph=True)[0]
        adv_img =  torch.clamp(data + adv_size*torch.sign(gd_nat), min=0, max=1)
        
        
        out_adv = model(adv_img)
        loss_adv = criterion(out_adv, target)
        gd_robust = torch.autograd.grad(loss_adv, robust_data, grad_outputs=None, only_inputs=True, retain_graph=False)[0]
        robust_data = torch.clamp(robust_data-beta*torch.sign(gd_robust), min=0, max=1)
        accuracy = torch.mean((torch.argmax(out_adv,dim=1)==target).float()).item()
        
        if batch_idx == 1:
            robust_dataset = robust_data.detach().cpu()
            fig = plt.figure
            plt.imshow(robust_data[0].detach().cpu().view(28,28).numpy(), cmap='gray')
            plt.show()  
            robust_label = robust_target.detach().cpu()
        else:
            robust_dataset = torch.cat((robust_dataset,robust_data.detach().cpu()),dim=0)
            robust_label = torch.cat((robust_label,robust_target.detach().cpu()),dim=0)
#         print(robust_dataset.shape)
        
        model.kill_gd()
        optimizer.step()
        
        pbar.update(1)
#         pbar.set_description(
#             'Train\t\tEpoch: {} [{}/{} ({:.0f}%)] \t'
#             'Batch Loss: {:.6f} \t'
#             'Batch Accuracy: {:.6f}'.format(
#                 epoch,
#                 batch_idx,
#                 len(train_loader),
#                 100. * batch_idx / len(train_loader),
#                 loss.item(),
#                 accuracy))
        
#         if debug and batch_idx > 20:
#             break
    pbar.close()
    return robust_dataset,robust_label

def robust_test(model, device, robust_train_loader,test_loader, criterion, num_classes, optimizer):
    train(model, criterion, device, num_classes, robust_train_loader, optimizer, 0)
#     model.eval()
#     size = 0
#     n_crr = 0
#     atk = torchattacks.PGD(model, eps=16/255, alpha=4/255, steps=5)
#     for i, (data, target) in enumerate(test_loader):
# #         print(data.shape)
#         data=data.view(data.shape[0],-1)
#         adv_images = atk(data, target).to(device)
# #         print(adv_images.shape)
# #         data.append(X)
#         target = target.to(device)
#         outputs = model(adv_images)
        
#         n_crr += torch.sum((torch.argmax(outputs,dim=1)==target).float()).item()
#         size+=data.shape[0]
#     print(n_crr/size)

class OpNorm(nn.Module):
    
    __constants__ = ['in_features', 'out_features']
    in_features: int
    out_features: int
    weight: torch.Tensor

    def __init__(self, in_features: int, out_features: int,
                 device=None, dtype=None) -> None:
        super(OpNorm, self).__init__()
        factory_kwargs = {'device': device, 'dtype': dtype}
        
        self.linear1=Linear(1*28*28,256,bias=False)
        self.linear2=Linear(256,64,bias=False)
        self.linear3=Linear(64,10,bias=False)
       
    
    def fill_gd(self,alpha):
        self.linear1.weight_grad = -alpha*self.linear1.weight.grad
        self.linear2.weight_grad = -alpha*self.linear2.weight.grad
        self.linear3.weight_grad = -alpha*self.linear3.weight.grad
        
    def kill_gd(self):
        self.linear1.weight_grad = None
        self.linear2.weight_grad = None
        self.linear3.weight_grad = None
        
    def forward(self, input: torch.Tensor) -> torch.Tensor:

        x = F.relu(self.linear1(input))
        x = F.relu(self.linear2(x))
        x = self.linear3(x)

        return x
    
model = OpNorm(in_features=32*32,out_features=C)

model = model.to(device)
# print(model)
opnorm={}
for key in model.state_dict():
    if 'weight' in key:
        opnorm[key]=[]

print(opnorm)
# transforms.Pad((padded_im_size - im_size)//2),transforms.Normalize(0.1307,0.3081)
transform = transforms.Compose([
                                transforms.ToTensor()])

train_dataset = datasets.MNIST('../data', train=True, download=True, transform=transform)

train_loader = torch.utils.data.DataLoader(
    train_dataset,
    batch_size=batch_size, shuffle=False)

# robust_train_loader = train_loader
robust_train_loader = torch.utils.data.DataLoader(
    train_dataset,
    batch_size=batch_size, shuffle=False)

test_dataset = datasets.MNIST('../data', train=False, download=True, transform=transform)
analysis_test_loader = torch.utils.data.DataLoader(
    datasets.MNIST('../data', train=False, download=True, transform=transform),
    batch_size=batch_size, shuffle=False)

if loss_name == 'CrossEntropyLoss':
    criterion = nn.CrossEntropyLoss()
    criterion_summed = nn.CrossEntropyLoss(reduction='sum')


optimizer = optim.SGD(model.parameters(),
                      lr=lr,
                      momentum=momentum,
                      weight_decay=weight_decay
                      )

lr_scheduler = optim.lr_scheduler.MultiStepLR(optimizer,
                                              milestones=epochs_lr_decay,
                                              gamma=lr_decay)



model = OpNorm(in_features=32*32,out_features=C)
model.load_state_dict(torch.load("checkpoint.ckpt"))
model = model.to(device)
model1 = OpNorm(in_features=32*32,out_features=C).cuda()
model1.load_state_dict(torch.load("checkpoint.ckpt"))

model3 = OpNorm(in_features=32*32,out_features=C).cuda()
model3.load_state_dict(torch.load("checkpoint.ckpt"))
# model2=model
# model3=model

cur_epochs = []
for epoch in range(1, opt.update_epoch+1):
    if epoch >1:
        robust_train_dataset = TensorDataset(robust_dataset.view(-1,28,28),robust_label)
        robust_train_dataset.targets = robust_label
        robust_train_loader = torch.utils.data.DataLoader(robust_train_dataset,batch_size=batch_size, shuffle=False)
    robust_dataset,robust_label = train_robust_data(model, criterion, device, C, train_loader,robust_train_loader, optimizer, epoch,alpha=opt.alpha,beta=opt.beta,adv_size = opt.adv_size)
    lr_scheduler.step()
#     if epoch%10==0:
#     test(model, device, C, analysis_test_loader)
    
model2 = OpNorm(in_features=32*32,out_features=C).cuda()
model2.load_state_dict(torch.load("checkpoint.ckpt"))
optimizer = optim.SGD(model.parameters(),
                      lr=opt.alpha,
                      )
print("Adv acc update 1 epoch")
robust_test(model2, device, robust_train_loader,analysis_test_loader, criterion, C, optimizer)
attack(model2,analysis_test_loader,device,adv_size=opt.adv_size)
print("Adv acc nat")
attack(model3,analysis_test_loader,device,adv_size=opt.adv_size)